START RST  10 GETCHAR
      CP   "*"
      ;make sure 1st char is *
      JP   NZ ERR6
      RST  10 NXTCHAR
      AND  9F
      CP   +27
      ;check 2nd is within
      ;alphabetic range
      ;(very simple test so may
      ;fail with some chars)
      JR   C INDEX
      XOR  A
INDEX ADD  A,A
      LD   HL,TABLE
      LD   B,0
      LD   C,A
      ADD  HL,BC
      LD   E,(HL)
      INC  HL
      LD   D,(HL)
      EX   DE,HL
      JP   (HL)
      ;jump to specific routine
      ;for each of the new 26
      ;commands
      ;subroutine to find the
      ;end of a word
SPACE RST  10 CHADD
      CP   " "
      RET  Z
      CP   ":"
      RET  Z
      CP   0D
      JR   NZ SPACE
      RET

ERR6  ;error vector
ERR6  ;vector for *A... ERR6  ;*N
ERR6  ;*B...            ERR6  ;*O
ERR6  ;*C...            PRINT ;*P
DRAW  ;*D...            ERR6  ;*Q
ERR6  ;*E...            ERR6  ;*R
ERR6  ;*F...            SCROL ;*S
ERR6  ;*G...            ERR6  ;*T
ERR6  ;*H...            ERR6  ;*U
ERR6  ;*I...            ERR6  ;*V
ERR6  ;*J...            ERR6  ;*W
ERR6  ;*K...            ERR6  ;*X
ERR6  ;*L...            ERR6  ;*Y
ERR6  ;*M...            ZAP   ;*Z

DRAW  CALL SPACE
      RST  10 EXPT1NM
      CP   ","
      ;check for separator
      JP   NZ ERR6
      RST  10 NXTCHAR
      RST  10 EXPT1NM
      CALL STEND
      ;now x & y are on the top
      ;of the stack
      RST  10 FNDINT1
      ;y co-ord into A
      LD   HL,COORDS+1
      ;address of previous y
      SUB  (HL)
      ;find relative y
      JR   C DRAW2
      ;if -ve, adjust it
      LD   D,1
DRAW1 LD   B,A
      PUSH BC
      PUSH DE
      RST  10 FNDINT1
      POP  DE
      POP  BC
      LD   HL,COORDS
      SUB  (HL)
      ;same for x co-ord
      JR   C DRAW3
      LD   E,1
      JR   DRAW4
DRAW2 LD   D,FF
      NEG
      JR   DRAW1
DRAW3 LD   E,FF
      NEG
DRAW4 LD   C,A
      RST  10 DRAWR
      ;perform actual drawing
      JP   END1

PRINT CALL SPACE
      RST  10 EXPT1NM
      CP   ","
      JP   NZ ERR6
      RST  10 NXTCHAR
      RST  10 EXPT1NM
      CP   ","
      JP   NZ ERR6
      RST  10 NXTCHAR
      RST  10 EXPT1NM
      CALL STEND
      RST  10 FNDINT1
      SLA  A
      SLA  A
      SLA  A
      LD   D,0
      LD   E,A
      LD   HL,(UDG)
      ADD  HL,DE
      ;HL contains the start
      ;of the required UDG data
      PUSH HL
      RST  10 FNDINT1
      PUSH AF
      RST  10 FNDINT1
      POP  BC
      LD   C,A
      ;BC contains the co-ords
      ;of the point to print to
      POP  DE
      LD   A,8
PRNT1 PUSH AF
      PUSH BC
      RST  10 PIXADD
      ;convert co-ords into an
      ;address and pointer in A
      PUSH AF
      PUSH HL
      PUSH DE
      RST  10 TEMPS
      ;set up colours
      RST  10 POATTR
      ;fill in attributes
      POP  HL
      LD   B,(HL)
      POP  DE
      EX   DE,HL
      POP  AF
      LD   C,0
      ;BC contains a byte of
      ;UDG data
      INC  A
PRNT2 SRL  B
      RR   C
      DEC  A
      JR   NZ PRNT2
      ;shift data along to the
      ;correct pixel within the
      ;screen byte
      LD   (HL),B
      INC  HL
      LD   (HL),C
      ;put it on the screen
      POP  BC
      DEC  B
      INC  DE
      ;next line
      POP  AF
      DEC  A
      JR   NZ PRNT1
      JP   END1

SCROL CALL SPACE
      RST  10 EXPT1NM
      CALL STEND
      RST  10 FNDINT1
      AND  3
      ;take n mode 4
      JR   Z SCRL0
      ;scroll right
      CP   1
      JR   Z SCRL1
      ;scroll up
      CP   2
      JR   Z SCRL2
      ;scroll left
      JR   SCRLB
      ;scroll down
SCRL0 LD   A,+192
      ;no of lines on screen
      LD   HL,+16384
      ;start of screen
SCRL3 AND  A
      ;clear carry
      LD   B,+32
      ;no of bytes per line
SCRL4 RR   (HL)
      ;shift 1 bit right
      INC  HL
      ;next byte on line
      DJNZ SCRL4
      DEC  A
      ;next line
      JR   NZ SCRL3
      JP   END1
SCRL2 LD   A,+192
      LD   HL,+22527
      ;end of screen
SCRL5 AND  A
      LD   B,+32
SCRL6 RL   (HL)
      ;shift 1 pixel left
      DEC  HL
      DJNZ SCRL6
      DEC  A
      JR   NZ SCRL5
      JP   END1
SCRL1 AND  A
      ;reset carry
      LD   DE,+16384
      ;1st byte of screen
      LD   B,3
      ;no of 'sections' to
      ;be scrolled
SCRL7 PUSH BC
      LD   A,8
      ;no of character lines
      ;per section
SCRL8 EX   AF
      LD   A,7
      ;no of pixel lines per
      ;character - 1
SCRL9 LD   H,D
      LD   L,E
      INC  H
      ;HL points to next pixel
      ;line
      PUSH HL
      LD   BC,+32
      LDIR
      POP  DE
      DEC  A
      JR   NZ SCRL9
      LD   BC,+1792
      SBC  HL,BC
      ;adjust pointer to start
      ;of next character line
      PUSH HL
      LD   BC,+32
      LDIR
      POP  DE
      EX   AF
      DEC  A
      JR   NZ SCRL8
      LD   BC,+1760
      ADD  HL,BC
      LD   D,H
      LD   E,L
      LD   BC,+32
      SBC  HL,BC
      ;adjust pointer for next
      ;screen section
      EX   DE,HL
      LDIR
      POP  BC
      DJNZ SCRL7
      LD   HL,+22496
      LD   B,+32
      ;now clear the last line
SCRLA LD   (HL),A
      ;A already contains 0
      INC  HL
      DJNZ SCRLA
      JP   END1
SCRLB LD   DE,+22527
      ;last location on screen
      LD   B,3
SCRLC PUSH BC
      LD   A,8
SCRLD EX   AF
      LD   A,7
SCRLE LD   H,D
      LD   L,E
      DEC  H
      PUSH HL
      LD   BC,+32
      LDDR
      POP  DE
      DEC  A
      JR   NZ SCRLE
      LD   BC,+1792
      ADD  HL,BC
      PUSH HL
      LD   BC,+32
      LDDR
      POP  DE
      EX   AF
      DEC  A
      JR   NZ SCRLD
      LD   BC,+1760
      SBC  HL,BC
      LD   D,H
      LD   E,L
      LD   BC,+32
      ADD  HL,BC
      EX   DE,HL
      LDDR
      POP  BC
      DJNZ SCRLC
      LD   HL,+16384
      LD   B,+32
      JP   SCRLA
      ;clear top line

ZAP   CALL SPACE
      RST  10 EXPT1NM
      CALL STEND
      RST  10 FNDINT1
      AND  A
      JR   Z ZAP0
      CP   1
      JR   Z ZAP1
      CP   2
      JR   Z ZAP2
      LD   (IY+0),0A
      RST  28
      ;integer out of range
      ;error code
ZAP1  LD   BC,180
      LD   HL,10
      JR   ZAP3
ZAP2  LD   BC,FEFF
      LD   HL,1820
ZAP3  LD   DE,4
      LD   A,10
ZAP4  PUSH BC
      PUSH DE
      PUSH HL
      PUSH AF
      RST  10 BEEPER
      ;make short burst of tone
      POP  AF
      POP  HL
      POP  DE
      POP  BC
      ADD  HL,BC
      ;change frequency
      DEC  A
      JR   NZ ZAP4
      JP   END1
ZAP0  DI
      LD   A,(BORDCR)
      RRCA
      RRCA
      RRCA
      ;A=border colour
      LD   H,4
ZAP5  LD   B,(HL)
      DEC  HL
ZAP6  DJNZ ZAP6
      ;'random' delay to
      ;produce white noise
      OUT  FE,A
      ;activate speaker
      XOR  10
      ;toggle speaker on/off
      EX   AF
      LD   A,H
      OR   L
      JR   Z ZAP7
      EX   AF
      JR   ZAP5
ZAP7  EI
      JP   END1
